package com.ibm.mqe.bridgemodel;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.mqe.*;
import com.ibm.mqe.mqbridge.*;
import com.ibm.uia.metamodel.*;
import com.ibm.uia.renderingInterface.*;
import com.ibm.uia.xml.*;
import com.ibm.mqe.model.*;
/**
 * Insert the type's description here.
 * Creation date: (12/07/2000 13:05:30)
 * @author: Phill van Leersum
 */
public class MQeBridgeConnectionProxy extends AbstractBridgeObject {
	private static final String CMD_CREATE_LISTENER = "Listener";
/**
 * adminMessage method comment.
 */
protected MQeMQBridgesAdminMsg bridgeTypeAdminMessage() {
	return connectionAdminMessage();
}
private MQeClientConnectionAdminMsg connectionAdminMessage() {
	try {
		return new MQeClientConnectionAdminMsg(
				getOwningQM().getBridge().getName(),
				getOwningQM().getName(),
				getName(), 
				false);
	} catch (Exception e) {
		_error("error creating MQeClientConnectionAdminMsg", e);
	}
	return null;
}
private boolean createListener(Renderer renderer, String[] data) {
	boolean changed = false;
	if (null != data) {
		String bridgeName = data[0];
		String type = BRIDGE_LISTENER_TYPE_NAME;
		UIObject uio = findExistingChild(type, bridgeName);
		if (null == uio) {
			uio = addNewChild(type, bridgeName);
		}
		if (null != uio) {
			((MQeObject)uio).commit(false);
		}
		changed = true;
	}
	return changed;
}
protected String getChildTypeName() {
	return BRIDGE_LISTENER_TYPE_NAME;
}
public final MQeBridgeQMProxy getOwningQM() {
	return (MQeBridgeQMProxy)getParent();
}
/**
 * Perform the actions represented by the supplied instance of 
 * <code>RenderableOperation</code> defined in te metamodel file.
 * If the operation was defined with a prompt then the String array
 * will be non-null, and will contain a string for every line of the prompt
 *
 * The renderer responsible for delivering the operation request is passed in
 * for convenience.
 *
 * Reply true if a stuctural refresh is reqired.
 */
public boolean performOperation(RenderableOperation op, Renderer renderer) {
	String[] data = op.getData();
	String command = op.getName();
	boolean reply = false;
	if (CMD_CREATE_LISTENER.equals(command)) {
		reply = createListener(renderer, data);
	} else {
		reply = super.performOperation(op, renderer);
	}
	return reply;
}
protected void setInitialValues(MQeFields mqef) {
	String portString = getAttributeValue(CONNECTION_PORT_ATTRIBUTE);
	int port = 0;
	try {
		port = Integer.parseInt(portString);
	} catch (NumberFormatException e) {
	}

	mqef.putInt( MQeCharacteristicLabels.MQE_FIELD_LABEL_PORT , port );
}
}
