package com.ibm.mqe.model;

import com.ibm.mqe.*;
import com.ibm.mqe.MQeAdminMsg;
import com.ibm.mqe.administration.*;
/**
 * Insert the type's description here.
 * Creation date: (10/5/2000 7:55:26 AM)
 * @author: 
 */
public abstract class AbstractRemoteQueue extends AbstractQueue {
public final MQeEnumeration browse() {
	MQeEnumeration enum = null;
	boolean[] success = getQueueManager().addTemporaryRoute(getQueueQueueManagerName());
	if (success[0]) {
		enum = super.browse();
	}
	if (success[1]) {
		getQueueManager().removeTemporaryRoute(getQueueQueueManagerName());
	}
	return enum;
}
public final boolean deleteMessage(MQeFields msg) {
	boolean reply = false;
	boolean[] success = getQueueManager().addTemporaryRoute(getQueueQueueManagerName());
	if (success[0]) {
		reply = super.deleteMessage(msg);
	}
	if (success[1]) {
		getQueueManager().removeTemporaryRoute(getQueueQueueManagerName());
	}
	return reply;
}
protected final String getQueueQueueManagerName() {
	return getAttributeValue(QQMNAME_ATTR);
}
/**
 * reply an admin message for the MQe resource 
 * represented by the receiver.
 */
public MQeQueueAdminMsg queueAdminMessage() {
	MQeQueueAdminMsg msg = null;
	try {
		msg = new MQeRemoteQueueAdminMsg();
		msg.setName(getQueueQueueManagerName(), getName());	// name of resource
	} catch (Exception e) {
		// error creating queueAdminMessage
		//e.printStackTrace(_log());
	}
	return msg;
}
public void testMessage(String queueQueueManagerName, String queueName, String txt) {
	boolean[] success = getQueueManager().addTemporaryRoute(getQueueQueueManagerName());
	if (success[0]) {
		super.testMessage(queueQueueManagerName, queueName, txt);
	}
	if (success[1]) {
		getQueueManager().removeTemporaryRoute(getQueueQueueManagerName());
	}
}
}
