package com.ibm.mqe.model;

import com.ibm.mqe.MQeFields;
import com.ibm.mqe.MQeAdminMsg;
import com.ibm.mqe.administration.*;
/**
 * Insert the type's description here.
 * Creation date: (10/5/2000 7:55:44 AM)
 * @author: 
 */
public final class RemoteQueue extends AbstractRemoteQueue {
	/**
 * Create the resource assciated with the receiver
 */
public boolean performCreate() {
	if (isToBeCreated()) {
		setStateCreating();
	}
	MQeAdminMsg replyMsg = null;
	try {
		MQeQueueAdminMsg msg = queueAdminMessage();
		MQeFields mqef = new MQeFields();
		boolean synchronous = getAttributeValue(QUEUE_MODE_ATTRIBUTE).equals(QUEUE_MODE_SYNC);
		if (synchronous) {
			mqef.putByte(msg.Queue_Mode, msg.Queue_Synchronous);
		} else {
			mqef.putByte(msg.Queue_Mode, msg.Queue_Asynchronous);
		}
		msg.create(mqef);
		replyMsg = putAdminMessage(msg);
	} catch (Exception e) {
		e.printStackTrace();
	}
	return handleMessage(replyMsg);
}
/**
 * reply an admin message for the MQe resource 
 * represented by the receiver.
 */
public MQeQueueAdminMsg queueAdminMessage() {
	MQeQueueAdminMsg msg = null;
	try {
		msg = new MQeRemoteQueueAdminMsg();
		msg.setName(getQueueQueueManagerName(), getName());	// name of resource
	} catch (Exception e) {
		// error creating queueAdminMessage
		//e.printStackTrace(_log());
	}
	return msg;
}
}
