package com.ibm.uia.metamodel;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import com.ibm.uia.xml.*;
import java.util.*;
/**
 * This type was created in VisualAge.
 */
public class OperationDefinition extends MetaModelComponent {
	
	public static final String OPERATION_TAG_TEXT = "operationDefinition";
	
	private static final String PATH = "path";
	private static final String PATH_STEP_NAME = "name";
	private static final String STRINGPROMPT = "stringPrompt";
	private static final String LOADFILEPROMPT = "loadFilePrompt";
	private static final String SAVEFILEPROMPT = "saveFilePrompt";
	private static final String PROMPT_CAPTION = "caption";
	private static final String PROMPT_ELEMENT = "element";
	private static final String DATALABEL = "caption";
	private static final String DATADEFAULT = "default";
	private static final String DIRECTORY = "directory";
	private static final String FILENAME = "filename";

	String promptType;
	private Vector path;
	private String _promptTitle;
	private Vector promptValues;
/**
 * OperationDefinition constructor comment.
 */
protected OperationDefinition() {
	super();
}
private void _setPromptTitle(String str) {
	if (_promptTitle != null) {
		System.out.println("resetting prompt title: " + str);
	}
	_promptTitle = str;
}
/**
 * create a DOM representation of the receiver using
 * the supplied document.  The Element generated should
 * be returned to the caller, and not appended to the 
 * document.  Subclasses can override this method but
 * are strongly recommended to call the superclass
 * method FIRST and decorate the returned element with their
 * specific data.
 * Note that the superclass is responsible for navigating
 * the standard tree structures, so this responsibility
 * is removed from subclass implementors
 */
protected Element generateDom(Document doc) {
	Element element = super.generateDom(doc);
	/*
		if (STRINGPROMPT.equals(element.getNodeName())) {
		_setPromptTitle(element.getAttribute(STRINGPROMPTTITLE));
		promptValues = new Vector();
		Enumeration enum = element.getChildren();
		while (enum.hasMoreElements()) {
			Element child = (Element)enum.nextElement();
			if (child.getNodeName().equals(PROMPT_ELEMENT)) {
				String[] entry = new String[] {
					child.getAttribute(DATALABEL), 
					child.getAttribute(DATADEFAULT)};
				promptValues.addElement(entry);
			}
		}
	}
	*/
	if (null != promptType) {
		Element promptEl = doc.createElement(promptType);
		promptEl.setAttribute(PROMPT_CAPTION, getPromptTitle());
		Enumeration enum = promptValues.elements();
		while (enum.hasMoreElements()) {
			String[] strs = (String[])enum.nextElement();
			Element el = doc.createElement(PROMPT_ELEMENT);
			el.setAttribute(DATALABEL, strs[0]);
			el.setAttribute(DATADEFAULT, strs[1]);
			promptEl.addChild(el);
		}
		element.addChild(promptEl);
	}
	return element;
}
/**
 * getDisplayPath method comment.
 */
public java.util.Enumeration getDisplayPath() {
	return path.elements();
}
public final MetaModel getMetaModel() {
	return null;
}
public final String[][] getPromptData() {
	String array[][] = new String[2][promptValues.size()];
	for (int i = 0; i < promptValues.size(); i++){
		String[] elem = (String[])promptValues.elementAt(i);
		array[0][i] = elem[0];
		array[1][i] = elem[1];
	}
	return array;
}
public final String getPromptTitle() {
	return _promptTitle;
}
/**
 * Reply the string used to identify an XML tag as representing
 * an instance of the receivers class
 */
public final String getTagName() {
	return OPERATION_TAG_TEXT;
}
public final boolean hasLoadFilePrompt() {
	return null != promptType
			&& promptType.equals(LOADFILEPROMPT)
				&& null != getPromptTitle();
}
public final boolean hasPrompt() {
	return hasStringPrompt() || hasLoadFilePrompt() || hasSaveFilePrompt();
}
public final boolean hasSaveFilePrompt() {
	return null != promptType
			&& promptType.equals(SAVEFILEPROMPT)
				&& null != getPromptTitle();
}
public final boolean hasStringPrompt() {
	return null != promptType 
			&& promptType.equals(STRINGPROMPT)
				&& null != getPromptTitle()
					&& null != promptValues
						&& promptValues.size() > 0;
}
public boolean isToggle() {
	return false;
}
/**
 * Initialise a child of the receiver from the given Element.
 */ 
protected UIAComponent parseChildElement(Element element) {
	UIAComponent uiac = null;
	if (STRINGPROMPT.equals(element.getNodeName())) {
		promptType = STRINGPROMPT;
		_setPromptTitle(element.getAttribute(PROMPT_CAPTION));
		promptValues = new Vector();
		Enumeration enum = element.getChildren();
		while (enum.hasMoreElements()) {
			Element child = (Element)enum.nextElement();
			if (child.getNodeName().equals(PROMPT_ELEMENT)) {
				String[] entry = new String[] {
					child.getAttribute(DATALABEL), 
					child.getAttribute(DATADEFAULT)};
				promptValues.addElement(entry);
			}
		}
	} else if (LOADFILEPROMPT.equals(element.getNodeName())) {
		promptType = LOADFILEPROMPT;
		_setPromptTitle(element.getAttribute(PROMPT_CAPTION));
		promptValues = new Vector();
		Enumeration enum = element.getChildren();
		while (enum.hasMoreElements()) {
			Element child = (Element)enum.nextElement();
			if (child.getNodeName().equals(PROMPT_ELEMENT)) {
				String[] entry = new String[] {
					child.getAttribute(DIRECTORY), 
					child.getAttribute(FILENAME)};
				promptValues.addElement(entry);
			}
		}
	} else if (SAVEFILEPROMPT.equals(element.getNodeName())) {
		promptType = SAVEFILEPROMPT;
		_setPromptTitle(element.getAttribute(PROMPT_CAPTION));
		promptValues = new Vector();
		Enumeration enum = element.getChildren();
		while (enum.hasMoreElements()) {
			Element child = (Element)enum.nextElement();
			if (child.getNodeName().equals(PROMPT_ELEMENT)) {
				String[] entry = new String[] {
					child.getAttribute(DIRECTORY), 
					child.getAttribute(FILENAME)};
				promptValues.addElement(entry);
			}
		}
	} else {
		uiac =  super.parseChildElement(element);
	}
	return uiac;
}
/**
 * Initialise the receiver from the given Element.
 */ 
protected void parseDom(Element element) {
	super.parseDom(element);
	
	path = new Vector();
	String pathString = super.getCaptionText();
	if (null == pathString || pathString.length() < 1) {
		path.addElement(getName());
	} else {
		StringTokenizer tok = new StringTokenizer(pathString, ".", false);
		String caption = tok.nextToken();
		while (tok.hasMoreTokens()) {
			path.addElement(caption);
			caption = tok.nextToken();
		}
		setCaptionText(caption);
	}
}
public final String[] perform(Renderer renderer) {
	String[] outData = null;
	if (hasStringPrompt()) {
		String[][] inData = getPromptData();
		outData = renderer.promptUserForStrings(getPromptTitle(), inData[0], inData[1]);
	} else if (hasLoadFilePrompt()) {
		String dir = null;
		String filename = null;
		if (null != promptValues && promptValues.size() > 0) {
			String[] data = (String[])promptValues.firstElement();
			dir = data[0];
			filename = data[1];
		}
		filename = renderer.getLoadFileName(getPromptTitle(), dir, filename);
		outData = new String[] {filename};
	} else if (hasSaveFilePrompt()) {
		String dir = null;
		String filename = null;
		if (null != promptValues && promptValues.size() > 0) {
			String[] data = (String[])promptValues.firstElement();
			dir = data[0];
			filename = data[1];
		}
		filename = renderer.getSaveFileName(getPromptTitle(), dir, filename);
		outData = new String[] {filename};
	}
	return outData;
}
}
