package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import com.ibm.uia.renderingInterface.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
/**
 * This type was created in VisualAge.
 */
public class OperationsPopupMenu extends PopupMenu {
	private Hashtable items;
/**
 * OperationsPopupMenu constructor comment.
 */
public OperationsPopupMenu() {
	this("");
}
/**
 * OperationsPopupMenu constructor comment.
 * @param label java.lang.String
 */
public OperationsPopupMenu(String label) {
	super(label);
	items = new Hashtable();
}
/* Examine the path and find the corresponsing sub menu
 * (the path is an enum of element. If is no present 
 * then create it
 */
private final Menu _targetFor(Enumeration enum) {
	if (enum.hasMoreElements()) {
		String path = enum.nextElement().toString();
		OperationsMenu menu = (OperationsMenu)items.get(path);
		if (null == menu) {
			menu = new OperationsMenu(path);
			items.put(path, menu);
			add(menu);
		}
		return menu._targetFor(enum);
	}
	return this;
}
final void add(RenderableOperation rop, Renderer renderer) {
	Menu m = _targetFor(rop.getDisplayPath());
	OperationsMenuItem mi = new OperationsMenuItem(rop, renderer);
	m.add(mi);
}
}
