package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import java.awt.*;
import com.ibm.uia.renderingInterface.*;
import java.util.*;
/**
 * This type was created in VisualAge.
 */
public class RendererPanel extends Panel {
	private TreePanel treePanel;
	private ListPanel attributePanel;
	private Label statusText;
	private Renderer renderer;
	private RendererNode mouseOver;
	private boolean usePopupMenu = true;
/**
 * RenderPanel constructor comment.
 */
public RendererPanel() {
	super(new BorderLayout());
	Panel p = new Panel(new java.awt.GridLayout(1,2));
	ScrollPane scr = new ScrollPane();
	treePanel = new TreePanel (this);
	scr.add(treePanel);
	scr.getVAdjustable().setUnitIncrement(12);
	p.add(scr);
	scr = new ScrollPane();
	attributePanel = new ListPanel(this);
	scr.add(attributePanel);
	scr.getVAdjustable().setUnitIncrement(12);
	p.add(scr);
	add("Center", p);

	statusText = new Label();
	
	add("South", statusText);
}
public void display(boolean recalculate) {
	if (recalculate) {
		treePanel.recalculate(true);
		attributePanel.recalculate(true);
	}
	attributePanel.repaint();
	treePanel.repaint();
}
public final Renderer getRenderer() {
	return renderer;
}
public final Enumeration getRootObjects() {
	return renderer.getRootObjects();
}
RendererTreeNode getTreeSelectedNode() {
	return (RendererTreeNode)treePanel._getSelectedNode();
}
final void listDoubleClicked(RendererNode tn) {
	if (tn instanceof RendererTreeNode) {
		RendererTreeNode rtn = (RendererTreeNode)tn;
		rtn.setExpanded(true);
		treeSelected(rtn);
		treePanel._setSelectedNode(rtn);
		rtn = rtn.getParent();
		while (null != rtn) {
			rtn.setExpanded(true);
			rtn = rtn.getParent();	
		} 
		//getRenderer().redisplay(true);
		treePanel.repaint();
	}
}
final void mouseOver(RendererNode rn) {
	if (mouseOver != rn) {
		mouseOver = rn;
		String status = "";
		if (null != rn) {
			status = rn.getHintText();
		}
		statusText.setText(status);
	}
}
public void paint(Graphics g) {
	//paintComponents(g);
}
public final void setRenderer(Renderer rf) {
	renderer = rf;
}
final void treeSelected(RendererNode tn) {
	RenderableObject ro = null;
	if (null != tn) {
		ro = ((RendererObjectNode)tn).getRenderableObject();
	}
	attributePanel.recalculate(true);
	if (null != renderer) {
		java.awt.Menu selectedMenu = null;
		if (null != tn) {
			selectedMenu = tn.getSelectedMenu(getRenderer());
		}
		renderer.setSelectedMenu(selectedMenu);
	}
	attributePanel.repaint();
}
protected boolean usePopupMenu() {
	return usePopupMenu;
}
protected void usePopupMenu(boolean use) {
	usePopupMenu = use;
}
}
