package com.ibm.uia.renderer;

/****************************************************************************/
/*                                                                          */
/* Program name: MQ Series Everyplace - Administration Tool                 */
/*                                                                          */
/*  Statement:  Licensed Materials - Property of IBM                        */
/*                                                                          */
/*              MQSeries SupportPac MSE1                                    */
/*              (C) Copyright IBM Corp. 2000                                */
/*                                                                          */
/****************************************************************************/
/*                                                                          */
/* Change history:                                                          */
/*                                                                          */
/* V1.0   15-08-2000  PTvL  Initial release                                 */
/*                                                                          */
/*==========================================================================*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import com.ibm.uia.renderingInterface.*;
/**
 * Insert the type's description here.
 * Creation date: (15/06/2000 14:25:13)
 * @author: Phill van Leersum
 */
public class UIOEditDialogue extends RendererDialogue implements ActionListener {
	private static final String OK = "Ok";
	private static final String CANCEL = "Cancel";
	private static final String RESET = "Reset";
	private MultipleAttributeEditPanel attrPanel;
	private RenderableObject rObject;
	boolean okPressed;
/**
 * EditDialogue constructor comment.
 * @param parent java.awt.Frame
 * @param title java.lang.String
 */
public UIOEditDialogue(Frame parent, String title, RenderableObject ro) {
	super(parent, title);
	rObject = ro;
	setLayout(new BorderLayout());
	Panel buttonPanel = new Panel(new FlowLayout(FlowLayout.CENTER));
	Button b = new Button(OK);
	b.addActionListener(this);
	buttonPanel.add(b);
	b = new Button(CANCEL);
	b.addActionListener(this);
	buttonPanel.add(b);
	b = new Button(RESET);
	b.addActionListener(this);
	buttonPanel.add(b);
	add("South", buttonPanel);
	Color bkgnd = Color.lightGray;//.brighter();
	attrPanel = new MultipleAttributeEditPanel(ro.getAllAttributes(), this);
	add("North", attrPanel);
	
	pack();
}
public void actionPerformed(ActionEvent e) {
	String cmd = e.getActionCommand();
	okPressed = false;
	if (OK.equals(cmd)) {
		okPressed();
	} else if (CANCEL.equals(cmd)) {
		cancelPressed();
	} else if (RESET.equals(cmd)) {
		attrPanel.reset();
	} else {
		okPressed();
	}
}
public void cancelPressed() {
	setVisible(false);
}
public void okPressed() {
	attrPanel.commit();
	setVisible(false);
	okPressed = true;
}
public final void show() {
	okPressed = false;
	super.show();
}
final void show(int mode) {
	Color c = getBackground();
	System.out.println("Colour: " + c);
	super.show();
}
}
